// THIS PLUGIN DROPS RANDOM OR EVERY "X" DEATHS A HEALTH PACKAGE AFTER A PLAYER DIES.
// RANDOM VALUE = 12 + PLAYERS ON SERVER! IF RANDOM = 9 A HEALTHPACK WILL BE DROPED.
// THE PLUGIN CONTAINS PARTS OF FEUERSTURMs DOD DROPHEALTHKIT SOURCE. (THANKS)
// I ALSO HAVE INCLUDED A HEALTHPACK MODEL FROM LEFT4DOD (THANKS). PLEASE PUT THAT ON YOUR SERVER + FASTDOWNLOAD!

// VERSION 1.2
// ADDED FUNCTION TO DROP A HEALTHPACK EVERY "X" DEATHS

// VERSION 1.3
// CHANGED RANDOM FUNCTION
// CVAR FOR CHOOSING MODEL TO USE
// FIXED: COUNTER REST ON MAPSTART

// VERSION 1.4
// CHANGED SDKHOOKS FROM TOUCH to STARTTOUCH
// BOTS CANNOT PICK UP HEALTHPACK!!
//

// VERSION 1.5
// ADDED CSS GIFT MODEL
//

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#define MAXENTITIES 1024
#define PLUGIN_VERSION "1.5"

public Plugin:myinfo = 
{
	name = "DoD:S Drop Random Healthpack Plugin",
	author = "Darkranger",
	description = "a dead player drops random a Healthpack!",
	version = PLUGIN_VERSION,
	url = "http://dark.asmodis.at"
}

static const String:g_HealthKit_Model[6][] = { "models/left4dod/medic_pack.mdl" , "models/props_misc/ration_box01.mdl" , "models/props_misc/bread-3.mdl" , "models/props_misc/flour_sack-1.mdl" , "models/props_misc/tobacco_box-1.mdl" , "models/items/cs_gift.mdl" }
new Handle:HealthKitDropTimer[MAXENTITIES+1] = INVALID_HANDLE
new String:g_HealthKit_Sound[] = { "object/object_taken.wav" }
new g_HealthKit_Skin[2] = { 0, 0 }
new Handle:kithealth = INVALID_HANDLE
new Handle:kittime = INVALID_HANDLE
new Handle:kitcount = INVALID_HANDLE
new Handle:dropmodel = INVALID_HANDLE
new kitcountcounter = 0

public OnPluginStart()
{	
	CreateConVar("dods_drop_random_health_version", PLUGIN_VERSION, "DoDs Gungame Healthpackage drop Plugin Version", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)
	SetConVarString(FindConVar("dods_drop_random_health_version"), PLUGIN_VERSION)
	kithealth = CreateConVar("dods_drop_health_ammount", "100", "<#> = amount of HP to add to a player picking up a Healthpackage", FCVAR_PLUGIN, true, 25.0, true, 300.0)
	kittime = CreateConVar("dods_drop_health_lifetime", "40", "<#> = number of seconds a dropped Healthpackage stays on the map", FCVAR_PLUGIN, true, 20.0, true, 180.0)
	kitcount = CreateConVar("dods_drop_health_counter", "0", "drop a Package every X deaths! 0 = disable - when enabled random drop is disabled", FCVAR_PLUGIN, true, 0.0, true, 60.0)
	dropmodel = CreateConVar("dods_drop_model", "5", "Model to use: 0=left4dod pack;1=MedicBox;2=Bread;3=FlourSack;4=TobaccoBox;5=CSS Gift", FCVAR_PLUGIN, true, 0.0, true, 5.0)
	AutoExecConfig(true, "dods_drop_random_health", "dods_drop_random_health");
	HookEvent("player_death", OnPlayerDeath, EventHookMode_Pre)
}

public OnMapStart()
{
	AddFileToDownloadsTable("models/left4dod/medic_pack.dx80.vtx")
	AddFileToDownloadsTable("models/left4dod/medic_pack.dx90.vtx")
	AddFileToDownloadsTable("models/left4dod/medic_pack.mdl")
	AddFileToDownloadsTable("models/left4dod/medic_pack.phy")
	AddFileToDownloadsTable("models/left4dod/medic_pack.vvd")
	AddFileToDownloadsTable("models/left4dod/medic_pack.sw.vtx")
	AddFileToDownloadsTable("materials/models/left4dod/medic_pack.vmt")
	AddFileToDownloadsTable("materials/models/left4dod/medic_pack.vtf")
	AddFileToDownloadsTable("models/items/cs_gift.dx80.vtx")
	AddFileToDownloadsTable("models/items/cs_gift.dx90.vtx")
	AddFileToDownloadsTable("models/items/cs_gift.mdl")
	AddFileToDownloadsTable("models/items/cs_gift.phy")
	AddFileToDownloadsTable("models/items/cs_gift.sw.vtx")
	AddFileToDownloadsTable("models/items/cs_gift.vvd")
	AddFileToDownloadsTable("materials/models/items/cs_gift.vmt")
	AddFileToDownloadsTable("materials/models/items/cs_gift.vtf")
	PrecacheModel(g_HealthKit_Model[0],true)
	PrecacheModel(g_HealthKit_Model[1],true)
	PrecacheModel(g_HealthKit_Model[2],true)
	PrecacheModel(g_HealthKit_Model[3],true)
	PrecacheModel(g_HealthKit_Model[4],true)
	PrecacheModel(g_HealthKit_Model[5],true)
	PrecacheSound(g_HealthKit_Sound, true)
	kitcountcounter = 0
}

public Action:OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(kitcount) == 0)
	{
		new randomplayercount = 12+GetClientCount()
		new randomdeath = GetURandomInt() % randomplayercount
		// FOR TESTING PrintToChatAll("RANDOM COUNT IS %d ", randomdeath)
		if (randomdeath == 9)
		{
			new client = GetClientOfUserId(GetEventInt(event, "userid"))
			new Float:deathorigin[3]
			GetClientAbsOrigin(client,deathorigin)
			deathorigin[2] += 5.0
			new healthkit = CreateEntityByName("prop_physics_override")
			SetEntityModel(healthkit,g_HealthKit_Model[GetConVarInt(dropmodel)])
			SetEntProp(healthkit, Prop_Send, "m_nSkin", g_HealthKit_Skin[0])
			DispatchSpawn(healthkit)
			TeleportEntity(healthkit, deathorigin, NULL_VECTOR, NULL_VECTOR)
			SDKHook(healthkit, SDKHook_StartTouch, OnHealthKitTouched)
			HealthKitDropTimer[healthkit] = CreateTimer(GetConVarFloat(kittime), RemoveDroppedHealthKit, healthkit, TIMER_FLAG_NO_MAPCHANGE)
			PrintToChatAll("PLAYER %N LOST A HEALTHKIT WITH %d HEALTH", client, GetConVarInt(kithealth))
			PrintHintTextToAll("PLAYER %N LOST A HEALTHKIT WITH %d HEALTH", client, GetConVarInt(kithealth))
			LogMessage("PLAYER %N drops a HealthPack random", client);
			return Plugin_Continue
		}
	}
	kitcountcounter++
	// FOR TESTING PrintToChatAll("COUNTER IS %d ", kitcountcounter)
	if (GetConVarInt(kitcount) == kitcountcounter)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"))
		new Float:deathorigin[3]
		GetClientAbsOrigin(client,deathorigin)
		deathorigin[2] += 5.0
		new healthkit = CreateEntityByName("prop_physics_override")
		SetEntityModel(healthkit,g_HealthKit_Model[GetConVarInt(dropmodel)])
		SetEntProp(healthkit, Prop_Send, "m_nSkin", g_HealthKit_Skin[0])
		DispatchSpawn(healthkit)
		TeleportEntity(healthkit, deathorigin, NULL_VECTOR, NULL_VECTOR)
		SDKHook(healthkit, SDKHook_StartTouch, OnHealthKitTouched)
		HealthKitDropTimer[healthkit] = CreateTimer(GetConVarFloat(kittime), RemoveDroppedHealthKit, healthkit, TIMER_FLAG_NO_MAPCHANGE)
		PrintToChatAll("PLAYER %N LOST A HEALTHKIT WITH %d HEALTH", client, GetConVarInt(kithealth))
		PrintHintTextToAll("PLAYER %N LOST A HEALTHKIT WITH %d HEALTH", client, GetConVarInt(kithealth))
		LogMessage("PLAYER %N drops a HealthPack with counter %d", client, kitcountcounter);
		kitcountcounter = 0
		return Plugin_Continue
	}
	return Plugin_Continue
}

public Action:OnHealthKitTouched(healthkit, client)
{
	if(client > 0 && client <= GetMaxClients() && healthkit > 0 && IsValidEntity(client) && IsClientInGame(client) && IsPlayerAlive(client) && !IsFakeClient(client) && IsValidEdict(healthkit))
	{
		new health = GetClientHealth(client)
		new healthkitadd = GetConVarInt(kithealth)
		SetEntityHealth(client, health + healthkitadd)
		KillHealthKitTimer(healthkit)
		PlayPickUpSound(client)
		RemoveEdict(healthkit)
		PrintToChat(client, "YOU PICKED UP A HEALTHKIT WITH %d HEALTH", GetConVarInt(kithealth))
		PrintHintText(client, "YOU PICKED UP A HEALTHKIT WITH %d HEALTH", GetConVarInt(kithealth))
		LogMessage("PLAYER %N picks up a HealthPack", client);
	}
	return Plugin_Handled
}

stock KillHealthKitTimer(healthkit)
{
	if(HealthKitDropTimer[healthkit] != INVALID_HANDLE)
	{
		CloseHandle(HealthKitDropTimer[healthkit])
	}
	HealthKitDropTimer[healthkit] = INVALID_HANDLE
}

stock PlayPickUpSound(client)
{
	EmitSoundToClient(client, g_HealthKit_Sound, SOUND_FROM_PLAYER,SNDCHAN_WEAPON,SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL)
}

public Action:RemoveDroppedHealthKit(Handle:timer, any:healthkit)
{
	HealthKitDropTimer[healthkit] = INVALID_HANDLE
	if(IsValidEdict(healthkit))
	{
		RemoveEdict(healthkit)
	}
	return Plugin_Handled
}